<script lang="ts">
  import { Button, Fileupload } from "flowbite-svelte";
  import { getNotificationsContext } from "svelte-notifications";
  import { type InputFormat, parseFile } from "$lib/components/pages/deployment/deployment";
  import {
    UpsertCheckCheckStore,
    UpsertCheckVariablesStore
  } from "$houdini";
  import ChecksList from "$lib/components/pages/deployment/ChecksList.svelte";
  import type { QueryResult } from "houdini";

  const { addNotification } = getNotificationsContext();

  let files: FileList;
  let input: InputFormat;
  const role = "event_admin";
  $: if (files?.length) {
    tryParse(files[0]);
  }

  async function tryParse(file: File) {
    try {
      const tmp = await parseFile(file);
      // sort checks by display order before assigning to input for display
      tmp.checks.sort((a, b) => a.display_order - b.display_order)
      input = tmp;
    } catch (e) {
      console.error(e);
      addNotification({
        text: `Error parsing file ${file.name}: ${(e as Error).message}`,
        position: "bottom-right",
        type: "error"
      });
    }
  }

  function verifyResult(result: QueryResult) {
    if (result.errors) {
      result.errors.map((e) => {
        addNotification({
          text: `Error uploading checks: ${(e as Error).message}`,
          position: "bottom-right",
          type: "error"
        });
      });
      throw new Error("error uploading something");
    }

    return result;
  }

  async function uploadChecks() {
    console.log("doing the scary thing!");
    const checks = input.checks.map((check) => ({
      name: check.name,
      description: check.description,
      display_name: check.display_name,
      args: check.args,
      type: check.type,
      script: check.script
    }));
    const insertCheckResult = await new UpsertCheckCheckStore().mutate(
      { checks },
      { metadata: { role }
    });
    verifyResult(insertCheckResult)

    // todo add check variables
    console.log("completed the scary thing!", insertCheckResult);
    addNotification({
      text: `Uploaded ${insertCheckResult.data?.insert_checks_checks?.affected_rows} checks.`,
      position: "bottom-right",
      type: "success"
    });

    const insertedChecks = insertCheckResult.data?.insert_checks_checks?.returning;
    if (!insertedChecks) {
      // for typing, this should never happen without result.errors being true
      throw new Error("couldn't insert check variables");
    }

    const checkVariables = [];
    for (let check of input.checks) {
      const check_id = insertedChecks.find((c: { id: string, name: string }) => c.name === check.name)?.id;
      const vars = check.vars ? input.vars[check.vars as keyof typeof input.vars] : null;

      if (!check_id || !vars) {
        addNotification({
          text: `No variables uploaded for ${check.name}`,
          position: "bottom-right",
          type: "warning",
        });
        continue;
      }

      checkVariables.push({ check_id, vars });
    }

    let insertVarsResult = await new UpsertCheckVariablesStore().mutate({input: checkVariables}, { metadata: { role } });
    verifyResult(insertVarsResult)
    addNotification({
      text: `Uploaded ${insertVarsResult.data?.insert_variables_check?.affected_rows} variables.`,
      position: "bottom-right",
      type: "success"
    });
  }
</script>

<!-- todo validate auth and user perms -->
<div class="container mx-auto">
  <div class="grid grid-cols-[200px_3fr_200px]">
    <span class="my-auto">Upload Spec File.</span>
    <Fileupload bind:files class="my-4 cursor-pointer" />
    <Button color="green" class="my-auto mx-3 py-3" on:click={uploadChecks}>Commit</Button>
  </div>

  <div class="grid grid-cols-5 text-center">
    <div>Order</div>
    <div>
      Name
    </div>
    <div>
      Subnet/Host
    </div>
    <div>Weight</div>
    <div>Script</div>
  </div>
  {#if input}
    <ChecksList {input} />
  {/if}
</div>